summaryrefslogtreecommitdiff
path: root/t/lflags-cxx.sh
diff options
context:
space:
mode:
Diffstat (limited to 't/lflags-cxx.sh')
-rw-r--r--t/lflags-cxx.sh68
1 files changed, 68 insertions, 0 deletions
diff --git a/t/lflags-cxx.sh b/t/lflags-cxx.sh
new file mode 100644
index 000000000..bcc42c767
--- /dev/null
+++ b/t/lflags-cxx.sh
@@ -0,0 +1,68 @@
+#! /bin/sh
+# Copyright (C) 2010-2013 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Check that $(LFLAGS) takes precedence over both $(AM_LFLAGS) and
+# $(foo_LFLAGS).
+# Please keep this in sync with the sister tests lflags.sh, yflags.sh
+# and yflags2.sh.
+
+. test-init.sh
+
+cat >fake-lex <<'END'
+#!/bin/sh
+echo '/*' "$*" '*/' >lex.yy.c
+echo 'extern int dummy;' >> lex.yy.c
+END
+chmod a+x fake-lex
+
+cat >> configure.ac <<'END'
+AC_SUBST([CXX], [false])
+# Simulate presence of Lex using our fake-lex script.
+AC_SUBST([LEX], ['$(abs_top_srcdir)'/fake-lex])
+AC_SUBST([LEX_OUTPUT_ROOT], [lex.yy])
+AC_SUBST([LEXLIB], [''])
+AC_OUTPUT
+END
+
+cat > Makefile.am <<'END'
+AUTOMAKE_OPTIONS = no-dependencies
+bin_PROGRAMS = foo bar
+foo_SOURCES = main.cc foo.ll
+bar_SOURCES = main.cc bar.l++
+AM_LFLAGS = __am_flags__
+bar_LFLAGS = __bar_flags__
+END
+
+$ACLOCAL
+$AUTOMAKE -a
+
+grep '\$(LFLAGS).*\$(bar_LFLAGS)' Makefile.in && exit 1
+grep '\$(LFLAGS).*\$(AM_LFLAGS)' Makefile.in && exit 1
+
+: > foo.ll
+: > bar.l++
+
+$AUTOCONF
+./configure
+run_make LFLAGS=__user_flags__ foo.cc bar-bar.c++
+
+cat foo.cc
+cat bar-bar.c++
+
+grep '__am_flags__.*__user_flags__' foo.cc
+grep '__bar_flags__.*__user_flags__' bar-bar.c++
+
+: